KeyPair (Java SE 26 & JDK 26)
Description: declaration: module: java.base, package: java.security, class: KeyPair
Keywords: java.security.KeyPair class

# Class KeyPair

java.lang.Object
java.security.KeyPair

All Implemented Interfaces:
  `Serializable, DEREncodablePREVIEW`

public final class KeyPair extends Object implements Serializable, DEREncodablePREVIEW
This class is a simple holder for a key pair (a public key and a private key). It does not enforce any security, and, when initialized, should be treated like a PrivateKey.

Since:
  1.1
See Also:
  - `PublicKey`
  - `PrivateKey`
  - Serialized Form

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `KeyPair(PublicKey publicKey, PrivateKey privateKey)`
  Constructs a key pair from the given public key and private key.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `PrivateKey`
  `getPrivate()`
  Returns a reference to the private key component of this key pair.
  `PublicKey`
  `getPublic()`
  Returns a reference to the public key component of this key pair.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Constructor Details

  - ### KeyPair

    public KeyPair(PublicKey publicKey, PrivateKey privateKey)
    Constructs a key pair from the given public key and private key.

    Note that this constructor only stores references to the public and private key components in the generated key pair. This is safe, because `Key` objects are immutable.

    Parameters:
      `publicKey` - the public key.
      `privateKey` - the private key.

- ## Method Details

  - ### getPublic

    public PublicKey getPublic()
    Returns a reference to the public key component of this key pair.
    Returns:
      a reference to the public key.

  - ### getPrivate

    public PrivateKey getPrivate()
    Returns a reference to the private key component of this key pair.
    Returns:
      a reference to the private key.